"""
Fixed Tree node classes
"""

# super class
class Node:    
    idx = None
    
    # For easier traversing
    # you should remember these:
    depth = None
    prefix = None
    
    # data holder (local log-likelihood)
    llik = 0.
    
    def __init__(self, idx):
        self.idx = idx
    
    def __cmp__(self, other):        
        if self.idx == other.idx : return 0
        return -1
    
    def __hash__(self):
        return self.idx
    
    pass # End of Tree Node class #

# internal node class
class InternNode(Node):
    
    __slots__ = ('idx','depth','prefix','llik','theta','lnTheta1','lnTheta0',
                 'size', 'E', 'Etot', 'Nr')
    
    # nodal log-likelihood
    llik = None
    # Graph cut prameters    
    theta = None
    lnTheta1 = None
    lnTheta0 = None
    # sufficient statistics
    size = None
    E = None
    Etot = None
    Nr = None
    
    def __repr__(self):        
        return "I_%d"%self.idx 
    
    pass # End of Internal Node definition


"""
|
| Internal-related methods (not to make class heavy?)
|
"""

# 
def intern_init_param(intern,NN,node_type=None):
    
    intern.size = 0.0
                    
    intern.theta = [0.0 for i in xrange(NN)]
    intern.lnTheta0 = [0.0 for i in xrange(NN)]
    intern.lnTheta1 = [0.0 for i in xrange(NN)]
        
    intern.E = [0.0 for i in xrange(NN)]
    intern.Etot = [0.0 for i in xrange(NN)]
    intern.Nr = [0.0 for i in xrange(NN)]
        
    return intern

def intern_update_param(intern,params):
    raise RuntimeError('Not Implemented yet')
    return intern


#
def merged_prefix(vl,vr):
    prefix = (vl.prefix & vr.prefix) >> 1    
    return prefix

#
def intern_find_left( r, MaxDepth ) :
    """
    range = intern_find_left( r, MaxDepth ) 
    
    where 'r' is internal node obj, and MaxDepth is the max-depth of a tree
    """
    r0 = r.prefix<<1
    r1 = r0 + 1
    d = r.depth
    lmost = r0 << (MaxDepth-(d+1))
    rmost = r1 << (MaxDepth-(d+1))
    return xrange(lmost, rmost)

#
def intern_find_right( r, MaxDepth ) :
    """
    range = intern_find_right( r, MaxDepth ) 
    
    where 'r' is internal node obj, and MaxDepth is the max-depth of a tree    
    """
    r1 = (r.prefix<<1) + 1
    d = r.depth
    lmost = r1 << (MaxDepth-(d+1))
    rmost = (r.prefix+1)<<(MaxDepth-d)
    return xrange(lmost, rmost)


# string representation
def intern_string(intern):    
    ret = ''
    theta = intern.theta
    if theta != None:
        ret += ', '.join( ['%.1f'%tt for tt in theta] )
    return ret
