'''
Created on May 27, 2009

link prediction module

@author: yongjinp
'''
from numpy import argwhere, zeros, cumsum, sum, argmax
import random

def linkupdate(tengine,cont=False):
    '''
    updates link probabilities of time-varying engine
    
    linkupdate(tengine,cont=False)
    
    where cont=True if 'Z' is stochastic (not 0/1)
    '''
    
    fbt = tengine.FBT; T = tengine.T; tdlist = tengine.tdList; times = tengine.times;
    
    for tt in xrange(T):
        td = tdlist[times[tt]]
        if cont :
            Z = discretize(td)
        else:
            Z = td.Z
        # print Z
        thislink = tengine.link[tt]
        # sample left-right
        for nn in fbt.nonleaves():
            left = fbt.left_terminals_under(nn)
            right = fbt.right_terminals_under(nn)
            
            VL = [vv[0] for ll in left for vv in argwhere(Z[:][:,ll]==1.)]
            VR = [vv[0] for rr in right for vv in argwhere(Z[:][:,rr]==1.)]
            
            for vl in VL:
                for vr in VR:
                    if vl > vr:
                        thislink[vr,vl] += nn.theta[tt]
                    else:
                        thislink[vl,vr] += nn.theta[tt]
        
        # sample collapsed  
        for nn in fbt.leaves():
            center = fbt.terminals_under(nn)
            
            VC = [vv[0] for cc in center for vv in argwhere(Z[:][:,cc]==1.)]
            nnvc = len(VC)
                    
            for vc1 in xrange(nnvc):
                vv1 = VC[vc1]
                for vc2 in xrange(vc1+1,nnvc):
                    vv2 = VC[vc2]
                    if vv1 > vv2 : 
                        thislink[vv2,vv1] += nn.theta[tt]
                    else:
                        thislink[vv1,vv2] += nn.theta[tt]
                
        tengine.link[tt] = thislink.T + thislink
        # print tengine.link[tt]
        
        pass # end of time iteration
            
    return 0

def discretize(td):    
    Z = td.Z
    mask = td.masking
    NN,KK = Z.shape    
    ret = zeros((NN,KK))    
    #for ii in xrange(NN):
    for ii in [ii for ii,mm in enumerate(mask) if mm==1.]:
        ret[ii,argmax(Z[ii,:])] = 1
    
    return ret


def linknormalize(tengine,ntimes):
    if ntimes < 1: return 0
    T = tengine.T;
    for tt in xrange(T):
       tengine.link[tt] /= ntimes
    return 0


